note
	description: "Huffman decoder."

class
	DECODER

feature -- Main operations

	decode (encoding: STRING; code_tree: NODE)
			-- Decode `encoding' using `code_tree' and store the result in `text'.
		require
			code_tree_exists: code_tree /= Void
			encoding_exists: encoding /= Void
			encoding_binary: across encoding as c all c.item = '0' or c.item = '1' end
		local
			char_pos: TUPLE [char: CHARACTER; pos: INTEGER]
			i: integer
		do
			text := ""
			from
				i := 1
			until
				i > encoding.count
			loop
				char_pos := code_tree.decode_from (encoding, i)
				text.append_character (char_pos.char)
				i := char_pos.pos
			end
		ensure
			text_exists: text /= Void
		end

feature -- Access

	text: STRING
			-- Result of last decoding.

end
