note
	description: "Leaf node in the code tree."

class
	LEAF

inherit
	NODE

create
	make

feature {NONE} -- Initialization

	make (char: CHARACTER; p: REAL_64)
			-- Create a leaf node that stores `char', which appears in the text with probability `p'.
		do
			character := char
			probability := p
		ensure
			character_set: character = char
		end

feature -- Access

	character: CHARACTER
		-- Character stored in the leaf.

feature -- Output

	show (indent: STRING)
			-- Pretty-print this subtree.
		do
			print (indent + "(" + character.out + ", " + (probability * 100).rounded.out + "%%)")
			io.new_line
		end

end
